unit uLogMaster;

{

      .
  :
  **     ,   uses ... , ... , uLogMaster; // .   
  1)   FileName      (SetFileName)
  2)                       (AssignLog)
  3)                   (AddToLog)
  4)  ,    (DestroyLog)
  Autumn, 10.09.09.

 /  /
 
 :
 var a: TLogMaster;
 begin
  a:=TLogMaster.Create;				//  
  a.SetFileName('log.txt');			//     
  a.AssignLog;						// 
  a.AddToLog(' '); 		//  
  FreeAndNil(a);					//        
 end;
 
}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  Dialogs;

type
 TLogMaster = class
  private
   FFileName: string;
   LogFile: Text;
  public
   procedure SetFileName(aName: string);
   procedure AssignLog;
   function DestroyLog: boolean;
   function GetFileName: string;
   procedure AddToLog(Event: string);
   property FileName: string read GetFileName write SetFileName;
 end;

implementation

{ TLogMaster }

procedure TLogMaster.AddToLog(Event: string);
begin
 try
   Append(LogFile);
   Writeln(LogFile,TimeToStr(Now)+': '+Event);
   CloseFile(LogFile);
 except
  ShowMessage(TimeToStr(Now)+' -      .');
 end;
end;

procedure TLogMaster.AssignLog;
begin
 try
  AssignFile(LogFile, FileName);
  Rewrite(LogFile);
   Writeln(LogFile,'------ File info -----');
   Writeln(LogFile,'## Log File From "'+ExtractFileName(Application.ExeName)+'"');
   Writeln(LogFile,'## Start Date: '+DateToStr(Now));
   Writeln(LogFile,'## Start Time: '+TimeToStr(Now));
   Writeln(LogFile,'##  Autumn');
   Writeln(LogFile,'------ Start Log -----');
   Writeln(LogFile,'');
   Writeln(LogFile,'');
  CloseFile(LogFile);
 except
  ShowMessage(TimeToStr(Now)+' -    -.');
 end;
end;

function TLogMaster.DestroyLog: boolean;
begin
 try
  if DeleteFile(FileName) then
   result:=True else Result:=false;
 except
  ShowMessage(TimeToStr(Now)+' -    -.');
 end;
end;

function TLogMaster.GetFileName: string;
begin
 Result:=FFileName;
end;

procedure TLogMaster.SetFileName(aName: string);
begin
  FFileName:=aName;
end;

end.
